import { App, CountSpec, Dict, DocumentData, OnCreateTrigger, OnCreateTriggerHandler, OnDeleteTrigger, OnDeleteTriggerHandler, WriteDocumentData } from './type';
import { Mapped } from './util';
declare function getStringField(data: DocumentData, fieldName: string): string;
declare function makeIncrementDocData(countName: string, value: 1 | -1): WriteDocumentData;
declare function makeOnCountedDocCreatedTrigger(app: App, counterCollectionName: string, viewName: string, countName: string, { groupBy: counterRefIdFieldName }: CountSpec): OnCreateTriggerHandler;
export declare function onCountedDocCreated<T extends string>(app: App, counterCollectionName: string, viewName: string, countSpecs: Mapped<T, CountSpec>): Mapped<T, OnCreateTrigger>;
declare function makeOnCountedDocDeletedHandler(app: App, counterCollectionName: string, viewName: string, countName: string, counterRefIdFieldName: string): OnDeleteTriggerHandler;
export declare function onCountedDocDeleted(app: App, counterCollectionName: string, viewName: string, countSpecs: Dict<CountSpec>): Dict<OnDeleteTrigger>;
export declare function materializeCountViewData(countSpecs: Dict<CountSpec>): DocumentData;
export declare const _: {
    makeOnCountedDocDeletedHandler: typeof makeOnCountedDocDeletedHandler;
    makeOnCountedDocCreatedTrigger: typeof makeOnCountedDocCreatedTrigger;
    makeIncrementDocData: typeof makeIncrementDocData;
    getStringField: typeof getStringField;
};
export {};
//# sourceMappingURL=view-count.d.ts.map