import { DocumentBuilder, GetDocTriggerOptions, OnCreateTrigger, OnCreateTriggerHandler, OnDeleteTrigger, OnDeleteTriggerHandler, OnUpdateTrigger, OnUpdateTriggerHandler } from '../type';
/**
 * Type safe and convenience firebase-functions wrapper
 */
declare function makeDocTriggerPath(collectionName: string): string;
declare function makeDocTrigger(collectionName: string, options?: GetDocTriggerOptions): DocumentBuilder;
export declare function makeOnCreateTrigger(collectionName: string, handler: OnCreateTriggerHandler): OnCreateTrigger;
export declare function makeOnUpdateTrigger(collectionName: string, handler: OnUpdateTriggerHandler): OnUpdateTrigger;
export declare function makeOnDeleteTrigger(collectionName: string, handler: OnDeleteTriggerHandler): OnDeleteTrigger;
export declare const _: {
    makeDocTrigger: typeof makeDocTrigger;
    makeDocTriggerPath: typeof makeDocTriggerPath;
};
export {};
//# sourceMappingURL=index.d.ts.map